\documentclass{article} 

\usepackage{amsmath}
\usepackage[english]{babel}
\usepackage{amssymb}
\usepackage{amsxtra}
\usepackage{listings}
\usepackage{graphics}
\usepackage{pgfplots}
\usepackage[utf8]{inputenc}

\newcommand{\refchapter}[1]{Chapter~\ref{#1}}
\newcommand{\refsec}[1]{Section~\ref{#1}}
\newcommand{\refeqn}[1]{Equation~(\ref{#1})}
\newcommand{\reffig}[1]{Figure~\ref{#1}}

\title{
{\bf \scriptsize RHEINISCH-WESTF\"ALISCHE TECHNISCHE HOCHSCHULE AACHEN \\
LuFG Informatik 12 (Prof. Dr. Uwe Naumann)} \vspace{2cm} \\
Examining Various Symbolic Regression Algorithms as Tools for Function and Curve Fitting}
\author{
Wanja Hentze (Matr.-Nr. 335148)
}

%\date{\includegraphics[height=2cm]{figures/logo_stce}}

\begin{document}

\lstloadlanguages{[ISO]C++}
\lstset{basicstyle=\small, numbers=left, numberstyle=\footnotesize,
  stepnumber=1, numbersep=5pt, breaklines=true, escapeinside={/*@}{@*/}}

\pagestyle{headings}

\maketitle
\newpage

\section*{Erklärung}

Hiermit versichere ich, dass ich die Arbeit selbständig verfasst und keine
anderen als die angegebenen Quellen und Hilfsmittel benutzt sowie Zitate 
kenntlich gemacht habe. \\
\\
\\
\\
\\
\\
\\
\\
Wanja Hentze \\
\\
Aachen, den 26.6.2016.

\newpage
\tableofcontents
\newpage

\section{Abstract}
\label{ch:2}

Curve fitting and surface fitting problems arise in any area of research where it is useful to succintly summarize the patterns and relationships in large datasets through a mathematical function.

Symbolic Regression is a relatively novel method of solving function fitting problems algorithmically without constraining the solution to a specific syntactical form. In theory, a Symbolic Regression library should be able to describe all datasets obeying a relationship that is expressible in the elementary terms known to it.

We present a tool for synthesizing egression problems and benchmark three SR implementations as well as a traditional spline-based fitting method against 40 of these problems. We argue from these results that these SR libraries are not up to par with 

\section{Introduction}
\label{ch:3}

\subsection{Problem Statement}

In the classic curve fitting problem, one is presented with a set of $n$ data points $(x_n, y_n)$ that admit some relationship. The task is then to find a curve, i.e. a function $f$ that closely approximates this data. Specifically, an accurate solution to the problem should minimize some norm of the error vector $\epsilon_n = | f(x_n) - y_n |$. Usually, the mean squared error norm is chosen, but the max and sum norms are also appropriate for some applications.

The surface fitting problem is the extension of curve fitting to 3-dimension data. That is, given three-dimensional points $(x_n, y_n, z_n)$, the aim is to find a  $f$ minimizing $\epsilon_n = | f(x_n, y_n) - y_n |$.

Generalizing to the n-dimensional manifold fitting problem is an obvious next step, but this is outside of the scope of this survey.

\subsection{Symbolic Regression}

Usually, when using software to fit curves and surfaces to data, one must first hypothesize the nature of the relationship the data admit by providing a \textbf{model function} $f(x:c)$ depending on both the input data $x$ and a number of parameters $c$. The curve fitting algorithm will then try to find values of $c$ that minimize the error in $f(x:c)$ while leaving the syntax of the function term itself untouched. This yields accurate results when the model function is chosen appropriately for the data but is also naturally prone to human error in misinterpreting data.

Symbolic Regression is a different approach altogether, as the algorithm does not require a model function to find a relationship in data. Instead, it constructs many different models symbolically from a pool of base symbols, evaluates them on the test data and eventually returns the best fitting one among them.\\
Traditionally, Symbolic Regression is implemented using Genetic Programming, in which the pool of functions is subjected to natural selection (selecting for fitness) and then re-filled using the offspring from the best-fitting models.
However, not this is not the only way to approach this problem, as we will see in the case of FFX.\\

SR is desirable for researchers because it is completely agnostic to the nature of the data being analyzed and can therefore be applied to many very different datasets without needing fine-tuning. In the optimal case, SR will yield very concise function terms, making it possible to summarise relationships more efficiently than some traditional function fitting solutions such as splines. \\

Although Symbolic Regression has existed at least since 1992\cite{Koza1992}, it has recently received an increase in popularity after a publication in Science\cite{eureqapaper} and the subsequent release of software "eureqa", a proprietary Symbolic Regression engine based on it which is marketed as a "Robotic Data Scientist". The goal of this survey was to 

\section{Algorithms and Implementations}

Any algorithm that solves regression problems symbolically, instead of being restrained to a single model or predefined set of models, is called a Symbolic Regression algorithm. The implementations of three of these algorithms were studied in this survey.

\subsection{GP-SR}
GP-SR is the application of Genetic Programming (GP) to Symbolic Regression.
GP-SR techniques are among the first Symbolic Regression algorithms.
In the usual setup, the initial generation is seeded with a number randomly generated function terms.
Every subsequent generation is 

The GP-SR implementation used in this study is the genetic.SymbolicRegressor class from the gplearn Python library, found at \cite{gplearnrepo}

\subsection{PGE}
PGE, or Prioritized Grammar Enumeration, is a recently developed algorithm based on GP-SR. Unlike regular GP-SR, PGE involves no randomness and will yield the same results deterministically. It uses dynamic programming techniques to reduce the size of the search space 

It works by generating all its models deterministically from a base pool, then using traditional least-squares regression to fit the parameters of these models to the data. Unlike GP-SR, these parameters are not considered part of the model.

The PGE implementation studied in this survey is pypge, found at\cite{pgerepo}.
pypge is a Python 3 library 

\subsection{FFX}
FFX, or Fast Function Extraction, is another Symbolic Regression Algorithm, first described in \cite{McConaghy2011}.

It works by generating all its models deterministically from a base pool, then using traditional least-squares regression to fit the parameters of these models to the data. Unlike in GP-SR, the values of these parameters are not considered part of the model, thereby reducing the search space.

The FFX implementation used in this study is Trent McConaghy's reference Python implementation found at \cite{ffxrepo}.

\section{Testing Setup}
\label{ch:4}
\subsection{Data}

There exist a number of both synthetic and real-world datasets for benchmarking SR implementations. However, some of these are created specifically for a certain library or piece of software and others admit rather simple relationships that are easily modelled using traditional regression tools.

Therefore, we present a Python tool called \textbf{modelgen} which generates random function terms from arbitrary symbols and then evaluates them to create datasets. The tool works by recursively building syntax trees from terminal symbols, unary operators and binary operators, until either a desired depth or a desired node count is reached. This is repeated until a function is found that is not indeterminate at any point in the desired input range and that is not constant in regard to any input variable.

For this survey, modelgen was used to construct 20 one-dimensional function terms of complexity at most 8 and depth at most 4 and 20 two-dimensional functions of complexity at most 6 and depth at most 3. The allowed symbols used are listed in the following table: \\
$$
\begin{tabular}{|r|l|}
  \hline
  terminal & constant, variable, $\pi$, $\phi$, $e$, constant$\times$ variable \\ \cline{2-2}
  unary & sin, cos, sqrt, exp, $()^2$, ln, cosh \\ \cline{2-2}
  binary & +,-,$\times$,/ \\
  \hline
\end{tabular}
$$

Constants were chosen uniformly at random from $[-5,5]$.
A $constant \times variable$ terminal is assigned both a constant and a variable symbol. Semantically, this expression evaluates to the product of the constant's value and the variable's value. This terminal was included in order to facilitate the creation of functions react differently to a large change in a variable than to a small change.\\

It should be noted that, while $modelgen$ will not create functions that are constant in any input variable, it does create functions that admit only a linear relationship between their output and one or even all input variables.
These functions are trivially fitted by most algorithms, but were still included in the survey in order to test the algorithms' best case runtimes.\\

The 1D functions were sampled 200 times, once along regularly spaced values from [-4,4] and once along points chosen uniformly at random from $[-4,4]$.
The 2D functions were sampled once on along a rectilinear 40x40 grid from $(-4,-4)$ to $(4,4)$ and once at 1600 points chosen uniformly at random from $[-4,4]^2$
\\

\subsection{Benchmarking Considerations}

For benchmarking the algorithms, a small wrapper called $evaluate.py$ was developed in order to run the sampled data through each of the libraries, capture their output in a unified format and report on their runtime as well as precision. \\

Part of the goal of this survey was to assess the utility of SR in comparison to traditional solutions. Therefore, spline interpolation methods from the industry standard scientific computing library SciPy were included in the benchmark. For the 1D samples, $interpolation.interp1d$ was used. For the 2D samples, $interpolation.RectBivariateSpline$ was used for the data sampled along a rectliniear grid and $interpolation.bisplrep$ was used for the data sampled at random points. As a spline created using every single data point would yield a perfect, yet very overfitted result, only part of the input data can be used for constructing the splines. In this benchmark, we use one in every ten points for $interp1d$ and one in every 40 points for the 2D splines.

All tests were done using Debian GNU/Linux 8 on a quad-core, 3.4GHz Intel Haswell CPU with 2-way SMT and 12GB of memory. SciPy, FFC and gplearn were executed using CPython 2.7.12 while pgepy was executed using CPython 3.5.2.

gplearn was initialized using the following parameters:\\
$$
\begin{tabular}{|r|l|}
\hline
generations   & 20    \\ \cline{2-2}
n\_jobs       & 8     \\ \cline{2-2}
transformer   & True  \\ \cline{2-2}
trigonometric & True  \\ \cline{2-2}
metric        & 'mse' \\ 
\hline
\end{tabular}
$$\\
All other parameters remained at the default.\\

pypge was run with the $09\_final/config\_explicit.yml$ configuration from the pypge repository, with the number of workers increased to 8 to utilize all threads, remote hosts disabled and $abs$ added to the available functions to accomodate sharp bends in the data. Also, the iteration count was halved to 6 as iterations beyond that mark proved to yield little improvement but take very long to complete.\\

When running FFX, the input was split alternatingly into training and validation data.\\

For the sake of consistency, the error metric optimized for by each algorithm was Mean Squared Error($mse$). Although this metric allows us to compare the accuracy of different algorithms on the same dataset, its values vary vildly across the different samples generated by $modelgen$, as the functions' values can have very different magnitudes, absolute values sometimes going up to $10^6$ and sometimes not exceeding $10^{-6}$. This is intended as the algorithms are expected to perform well regardless of the magnitude of input values. However, for final results, it is favorable to have the error metrics be comparable across all samples. Therefore, all resulting $mse$s were normalized by dividing by the variance of the sample.\\

As pypge and gplearn use multithreading, while $scipy.interpolation$ and FFX do not, it is hard to fairly compare CPU time between them. Instead, the simple wall-clock time elapsed between the start and the end of each fitting procedure was taken as a measure of runtime. This also more closely resembles the real-world needs of researchers.\\

\section{Results}
\label{ch:5}



Evidently, pypge was the slowest performing program by far, even after halving the default number of iterations und using 8 threads. However, this increase in runtime is also couple with more precision, in which pypge clearly outperforms gplearn and ffx.\\

FFX is the fastest program studied by a large margin. This falls in line with the authors' claims of very quick results. However, it is also yielded the least precise fits out of all the programs.\\

In comparison to the $spline$ results, the $SR$ results seem quite sobering.
When compared to the spline fitting algorithms, on average, FFX took DATA times longer, gplearn took DATA times longer and pypge took DATA times longer.


For the complete results, refer to the appendix.

\section{Conclusion}
\label{ch:6}


\nocite{}
\bibliographystyle{plain}
\bibliography{symreg}

\newpage
\appendix

\end{document}
